<?php
/**
 * Copyright © 2016 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */
namespace Threepartment\Debitpayment\Model;

use Magento\Checkout\Model\ConfigProviderInterface;
use Magento\Framework\Escaper;
use Magento\Payment\Helper\Data as PaymentHelper;

class InstructionsConfigProvider implements ConfigProviderInterface
{
    /**
     * @var string[]
     */
    protected $methodCodes = [
        Debitpayment::PAYMENT_METHOD_DEBITPAYMENT_CODE
    ];

    /**
     * @var \Magento\Payment\Model\Method\AbstractMethod[]
     */
    protected $methods = [];

    /**
     * @var Escaper
     */
    protected $escaper;

    /**
     * @param PaymentHelper $paymentHelper
     * @param Escaper $escaper
     */
    public function __construct(
        PaymentHelper $paymentHelper,
        Escaper $escaper
    ) {
        $this->escaper = $escaper;
        foreach ($this->methodCodes as $code) {
            $this->methods[$code] = $paymentHelper->getMethodInstance($code);
        }
    }

    /**
     * {@inheritdoc}
     */
    public function getConfig()
    {
        $config = [];
        foreach ($this->methodCodes as $code) {
            if ($this->methods[$code]->isAvailable()) {
                $config['payment']['instructions'][$code] = $this->getInstructions($code);
                $config['payment']['moreinfo'][$code] = $this->getMoreInfo($code);
                $config['payment']['remoteURL'][$code] = $this->getRemoteURL($code);
                $config['payment']['autopopulate'][$code] = $this->getAutoPopulate($code);
                $config['payment']['checkbox'][$code] = $this->getCheckbox($code);
                $config['payment']['checkboxtext'][$code] = $this->getCheckboxText($code);
            }
        }
        return $config;
    }

    /**
     * Get instructions text from config
     *
     * @param string $code
     * @return string
     */
    protected function getInstructions($code)
    {
        return nl2br($this->escaper->escapeHtml($this->methods[$code]->getInstructions()));
    }

    /**
     * Get remote URL from config
     *
     * @param string $code
     * @return string
     */
    protected function getRemoteURL($code)
    {
        return nl2br($this->escaper->escapeHtml($this->methods[$code]->getRemoteURL()));
    }

    /**
     * Get checkbox option from config
     *
     * @param string $code
     * @return string
     */
    protected function getCheckbox($code)
    {
        return nl2br($this->escaper->escapeHtml($this->methods[$code]->getCheckbox()));
    }

    /**
     * Get checkbox text from config
     *
     * @param string $code
     * @return string
     */
    protected function getCheckboxText($code)
    {
        return nl2br($this->escaper->escapeHtml($this->methods[$code]->getCheckboxText()));
    }

    /**
     * Get Autopopulate Value
     *
     * @param string $code
     * @return string
     */
    protected function getAutoPopulate($code)
    {
        return nl2br($this->escaper->escapeHtml($this->methods[$code]->getAutoPopulate()));
    }

    /**
     * Get More Info
     *
     * @param string $code
     * @return string
     */
    protected function getMoreInfo($code)
    {
        return nl2br($this->escaper->escapeHtml($this->methods[$code]->getMoreInfo()));
    }
}
